<?php
/**
 * @copyright   Copyright (C) Chatbro. All rights reserved.
 * @license     GNU General Public License version 2 or later.
 */

defined('_JEXEC') or die();
defined('CHATBROENGINE') || die();

use ChatbroChatbroappInterfacesIcbro_utils_backend as IcbroUtilsBackend;
use ChatbroChatbroappApiCbro_api as CbroApi;

use Joomla\CMS\Factory;
use Joomla\CMS\Uri\Uri;
use Joomla\CMS\Language\Text;

class ChatbroChatbroappBackendsCbro_utils_backend implements IcbroUtilsBackend
{
	private static $scripts_count = 0;
	private static $styles_count = 0;
	private $cms;

	public function __construct($cms)
	{
		$this->cms = $cms;
	}

	function get_site_url()
	{
		return $this->cms->getStoreUrl();
	}

	function generated_scripts()
	{
		$get_chats =
			Uri::base() .
			'index.php?option=com_chatbrocomponent&task=Ajax.gcu&' .
			Factory::getApplication()->getFormToken() .
			'=1&format=json';
		$create_chat =
			Uri::base() .
			'index.php?option=com_chatbrocomponent&task=Ajax.cc&' .
			Factory::getApplication()->getFormToken() .
			'=1&format=json';
		$delete_chat =
			Uri::base() .
			'index.php?option=com_chatbrocomponent&task=Ajax.dc&' .
			Factory::getApplication()->getFormToken() .
			'=1&format=json';
		$update_chat =
			Uri::base() .
			'index.php?option=com_chatbrocomponent&task=Ajax.uc&' .
			Factory::getApplication()->getFormToken() .
			'=1&format=json';
		$save_settings =
			Uri::base() .
			'index.php?option=com_chatbrocomponent&task=Ajax.ss&' .
			Factory::getApplication()->getFormToken() .
			'=1&format=json';
		?>

    <script>
      var cBroGlobals = {
        saveSettingsUrl: "<?php echo $save_settings; ?>",
        createChatUrl: "<?php echo $create_chat; ?>",
        deleteChatUrl: "<?php echo $delete_chat; ?>",
        updateChatUrl: "<?php echo $update_chat; ?>",
        getFaqUrl: "/faq/get",
        getChatsUrl: "<?php echo $get_chats; ?>",
        cms: "<?php echo CbroApi::get_platform_name(); ?>",
        shortcodeTemplateType: 'php',
        chatShortcodeTemplate: '$app->get("chatbro")->render([ "id" => "%s", "static" => true]);',
        childShortcodeTemplate: '$app->get("chatbro")->render([ "id" => "%s", "child" => true, "title" => "Child chat %s"]);',
        dropDownConflict: false
      };
    </script>
    <?php
	}

	function get_site_domain()
	{
		$url = self::get_site_url();
		if (!preg_match('/^.+:\/\/([^\/\:]+)/', $url, $m)) {
			return '';
		}

		return $m[1];
	}

	function get_platform()
	{
		return 'joomla-plugin-' . 1 . '.' . 2;
	}

	function is_front_page()
	{
    $uri = Uri::getInstance();
    $path = $uri->getPath();
    $query = $uri->getQuery();
		return ($path == '/' || $path == '/index.php') && empty($query);
	}

	function match_path($path, $patterns)
	{
		$to_replace = ['/(\r\n?|\n)/', '/\\\\\*/'];
		$replacements = ['|', '.*'];
		$patterns_quoted = preg_quote($patterns, '/');
		$regexps =
			'/^(' .
			preg_replace($to_replace, $replacements, $patterns_quoted) .
			')$/';
		return (bool) preg_match($regexps, $path);
	}

	function check_path($display, $selected_pages)
	{
		$uri = Uri::getInstance();
    $query = $uri->getQuery();
    $path = $uri->getPath();

    $full_url = $path . (empty($query) ? '' : '?' . $query);

		$page_match = false;
		$selected_pages = trim($selected_pages);

		if ($selected_pages != '') {
			if (function_exists('mb_strtolower')) {
				$pages = mb_strtolower($selected_pages);
				$path = mb_strtolower($full_url);
			} else {
				$pages = strtolower($selected_pages);
				$path = strtolower($full_url);
			}

			$page_match = self::match_path($path, $pages);

			if ($display == 'except_listed') {
				$page_match = !$page_match;
			}
		}

		return $page_match;
	}

	function enque_script()
	{
	}

	function enque_style()
	{
	}

	function translate($text)
	{
		return Text::_($text);
	}

	function get_locale()
	{
		// Получение текущего языка
		$language = Factory::getLanguage();
		$currentLanguage = $language->getTag();
		return $currentLanguage;
	}

	function get_request_var($var_name)
	{
		$input = Factory::getApplication()->input;
    $filter = 'STRING';

    if ($var_name == 'chatbro_chat_selected_pages') {
      $filter = 'HTML';
    }

		return $input->post->get($var_name, null, $filter);
	}

	function get_home_url()
	{
		return $this->cms->getStoreUrl();
	}

	function get_default_profile_url()
	{
		return $this->cms->getStoreUrl();
	}

	/*
  Возвращает значение атрибута data-offset-top (кол-во пикселей отступа от верха
  экрана, доехав до которого чат перестает скроллироваться) для чата поддержки.
  */
	function get_support_chat_data_offset_top()
	{
		return 53;
	}
}

?>
